/*!
	\file compilationfailederror.h
	\brief Contains the CompilationFailedError class
	\author Kevin André
	
	Copyright (C) 2005, 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2005-06-11
// Last time modified:	2007-10-25

#ifndef DEF_COMPILATIONFAILEDERROR_H
 #define DEF_COMPILATIONFAILEDERROR_H
 
 #include "common/exception.h"

namespace HYPER_Compiler {
	
	/// An exception originating from a compile error
	class CompilationFailedError : public HYPER_Common::Exception {
	public:
		CompilationFailedError(bool fatalError = false);
		
		/// Was the error a fatal one?
		bool wasFatal() const;
		
	private:
		bool fFatal;
	};
}
#endif
