/*!
	\file debug.h
	\brief Contains facilities for easy debug output
	\author Kevin André
	
	Copyright (C) 2005, 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2005-10-01
// Last time modified:	2008-02-15

#ifndef DEF_DEBUG_H
 #define DEF_DEBUG_H
 
 #include "common/utf8textflowstream.h"

namespace HYPER_Compiler {
	
	/// For debug output
	extern HYPER_Common::UTF8TextFlowStream debug;
	
	class IndentDebug : public HYPER_Common::Indent {
	public:
		IndentDebug();
	};
	
	/// Provides some debug functionality
	class Debug {
	public:
		/// Enable or disable debug output
		static void enableDebugOutput(bool value = true);
		
		/// Prints a "FIXME: " and a given string to the console
		static void fixMe(HYPER_Common::UTF8String);
		
		/// Prints a "TODO: " and a given string to the console
		static void toDo(HYPER_Common::UTF8String);
	};
}
#endif
