/**
	\file console.h
	\brief Contains the Console class.
	\author Kevin André
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2007-04-24
// Last time modified:	2008-03-28

#ifndef DEF_CONSOLE_H
 #define DEF_CONSOLE_H
 
 #include "streams_fwdecl.h"
 
namespace HYPER_Common {
	
	/// Console output utilities
	class Console {
	public:
		
		/// Get a plain stdout stream
		static UTF8PushStream& getStdOut();
		
		/// Get a plain stderr stream
		static UTF8PushStream& getStdErr();
		
		/// Gets a stdout stream with line wrapping
		static UTF8TextFlowStream& getTextFlowStdOut();
		
		/// Gets a stderr stream with line wrapping
		static UTF8TextFlowStream& getTextFlowStdErr();
		
	private:
		static UTF8TextFlowStream* create(UTF8PushStream&);
	};
}
#endif
