/**
	\file copyright.h
	\author Kevin André
	\brief Contains the project's copyright strings for printing.
	
	Copyright (C) 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2008-09-13
// Last time modified:	2009-01-01

#ifndef DEF_PROJECT_COPYRIGHT_H
 #define DEF_PROJECT_COPYRIGHT_H
 
 #include "utf8string.h"

namespace HYPER_Common {
	
	class Copyright {
	public:
		static UTF8String copyrightYearsAndAuthor() {
			return UTF8STR(
				"Copyright %1 2004, 2005, 2006, 2007, 2008, 2009  "
				"Kevin Andr\xC3\xA9"
			).compose(CodePoint::copyright());
		}
		
		static UTF8String licenseAndDisclaimer() {
			return UTF8STR(
				"This is free and open source software. You are allowed to "
				"use, copy, modify and redistribute it under the terms of the "
				"GNU General Public License version 3 or (at your option) any "
				"later version. There is ABSOLUTELY NO WARRANTY, to the extent "
				"permitted by law."
			);
		}
	};
}
#endif
