/*!
	\file logicutil.h
	\brief Contains utilities for logic
	\author Kevin André
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created: 		2007-04-14
// Last time modified: 	2007-04-14

#ifndef DEF_LOGICUTIL_H
 #define DEF_LOGICUTIL_H

namespace HYPER_Common {
	
	class LogicUtil {
	public:
		
		/// Check if at most one of the parameters is true
		static bool exclusive(bool a, bool b) {
			return !(a && b);
		}
		
		/// Check if at most one of the parameters is true
		static bool exclusive(bool a, bool b, bool c) {
			return (a ? 1 : 0) + (b ? 1 : 0) + (c ? 1 : 0) <= 1;
		}
		
		/// Check if at most one of the parameters is true
		static bool exclusive(bool a, bool b, bool c, bool d) {
			return (a ? 1 : 0) + (b ? 1 : 0) + (c ? 1 : 0) + (d ? 1 : 0) <= 1;
		}
		
	};
}
#endif
