/**
	\file paths_fwdecl.h
	\author Kevin André
	\brief Contains forward declarations for all path classes.
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2007-10-25
// Last time modified:	2007-10-25

#ifndef DEF_PATH_FWDECL_H
 #define DEF_PATH_FWDECL_H

namespace HYPER_Common {
	
	// path classes
	class FilePath;
	class UnixFilePath;
	
	// other
	class InvalidPathStringException;
	
}
#endif
