/*!
	\file pullstream.h
	\brief Contains the PullStream class
	\author Kevin André
	
	Copyright (C) 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created: 		2008-02-03
// Last time modified: 	2008-02-20

#ifndef DEF_PULLSTREAM_H
 #define DEF_PULLSTREAM_H
 
 #include "streambase.h"

namespace HYPER_Common {
	
	/// Abstract class that represents a stream you pull data from
	template<class T>
	class PullStream : public StreamBase<T> {
	public:
		virtual ~PullStream() { /*empty*/ }
		
		/// Look at the current data
		virtual bool look(typename StreamBase<T>::DataType& d) = 0;
		
		/// Pull new data from the stream
		virtual bool pullNext() = 0;
		
	protected:
		PullStream() { /*empty*/ }
	};
}
#endif
