/**
	\file streams_fwdecl.h
	\author Kevin André
	\brief Contains forward declarations for all stream classes.
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2007-07-26
// Last time modified:	2008-03-16

#ifndef DEF_STREAMS_FWDECL_H
 #define DEF_STREAMS_FWDECL_H

namespace HYPER_Common {
	
	// input streams
	template <class T> class BufferedPullStream;
	class CharBufferInputStream;
	template <class T> class OverlayPullStream;
	template <class T> class PullStream;
	class UTF8StdInStream;
	
	// output streams
	template <class T> class PushStream;
	class TextFlowStream;
	class UTF8PushStream;
	class UTF8StdOutStream;
	class UTF8TextFlowStream;
	
	// stream processors
	template <class IN, class OUT> class StreamProcessor;
	class UTF8Decoder;
	class UTF8Encoder;
	class UTF8Verifier;
	
	// utilities
	class TextFlowOptions;
	class Indent;
	
}
#endif
