/*!
	\file utf8.h
	\brief Implements some UTF-8 functionality
	\author Kevin André
	
	Copyright (C) 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created: 		2008-03-01
// Last time modified: 	2008-03-01

#include "utf8.h"

#include <sstream>

namespace HYPER_Common {
	
	// FIXME : do not rely on stringstream
	void UTF8Byte::encode(long double d, UTF8Consumer& cons) {
		std::ostringstream oss;
		oss << d;
		std::string s = oss.str();
		for (std::string::size_type i = 0; i < s.size(); ++i) {
			cons.consume(UTF8Byte(s[i]));
		}
	}
}	
