/*!
	\file utf8encoder.h
	\brief Contains the UTF8Encoder class
	\author Kevin André
	
	Copyright (C) 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created: 		2008-02-12
// Last time modified: 	2008-03-16

#ifndef DEF_UTF8ENCODER_H
 #define DEF_UTF8ENCODER_H
 
 #include "streamprocessor.h"
 #include "utf8.h"

namespace HYPER_Common {
	
	/// Class that encodes unicode characters into UTF-8
	class UTF8Encoder : public StreamProcessor<CodePoint, UTF8Byte> {
	public:
		
		ProcessStatus processData(std::deque<CodePoint>& input,
			bool endOfInputReached, std::deque<UTF8Byte>& output,
			State& processState) const;
		
	private:
		class UTF8Dequer;
	};
}
#endif
