/*!
	\file utf8stdoutstream.h
	\brief Contains the UTF8StdOutStream class
	\author Kevin André
	
	Copyright (C) 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created: 		2008-02-03
// Last time modified: 	2008-02-06

#ifndef DEF_UTF8STDOUTSTREAM_H
 #define DEF_UTF8STDOUTSTREAM_H
 
 #include "utf8pushstream.h"
 
 #include <ostream>

namespace HYPER_Common {
	
	/// Class that pushes UTF-8 bytes to a std::ostream
	class UTF8StdOutStream : public UTF8PushStream {
	public:
		UTF8StdOutStream(std::ostream& s);
		
		bool push(UTF8Byte d);
		bool streamOK() const;
		PositionType streamPosition() const;
		
	private:
		std::ostream& fStream;
		PositionType fPos;
	};
}
#endif
