/*!
	\file assignmentoperator.cxx
	\brief Implements the AssignmentOperator class
	\author Kevin André
	
	Copyright (C) 2005, 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2005-12-17
// Last time modified:	2009-01-25

#include "assignmentoperator.h"

namespace HYPER_Compiler {
	
	AssignmentOperator::AssignmentOperator(
		Operators::AssignmentOperator op, Type const* rValueType,
		Location const* loc)
	 : fOp(op), fRValueT(rValueType), fLoc(loc)
	{
		// no action
	}
	
	AssignmentOperator::~AssignmentOperator() {
		// no action
	}
	
	Operators::AssignmentOperator AssignmentOperator::getOperator() const {
		return fOp;
	}
	
	Type const* AssignmentOperator::getRValueType() const {
		return fRValueT;
	}
	
	Location const* AssignmentOperator::getLocation() const {
		return fLoc;
	}
}
