/*!
	\file integersizes.cxx
	\author Kevin André
	\brief Implementations for the IntegerSize enum
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:	2009-02-08
// Last modified:	2009-02-08

#include "integersizes.h"

#include "base/asserts.h"

namespace HYPER_Compiler {
	
	unsigned toNumber(IntegerSize s) {
		switch (s) {
		case k8Bit:
			return 8;
		case k16Bit:
			return 16;
		case k32Bit:
			return 32;
		case k64Bit:
			return 64;
		default:
			hyp_assert_unreachable();
		}
	}
	
	IntegerSize toIntegerSize(Platform::WordSize s) {
		switch (s) {
		case Platform::k32Bit:
			return k32Bit;
		case Platform::k64Bit:
			return k64Bit;
		default:
			hyp_assert_unreachable();
		}
	}
	
}
