/*!
	\file integersizes.h
	\author Kevin André
	\brief Contains the IntegerSize enum
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:	2009-02-08
// Last modified:	2009-02-08

#ifndef DEF_INTEGERSIZES_H
 #define DEF_INTEGERSIZES_H
 
 #include "base/platform.h"

namespace HYPER_Compiler {
	
	enum IntegerSize {
		k8Bit,
		k16Bit,
		k32Bit,
		k64Bit
	};
	
	unsigned toNumber(IntegerSize s);
	
	IntegerSize toIntegerSize(Platform::WordSize s);
	
}
#endif
