/**
	\file nameddeclareditem.h
	\brief Contains the NamedDeclaredItem class
	\author Kevin André
	
	Copyright (C) 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:	2007-01-01
// Date modified:	2008-02-20

#ifndef DEF_NAMEDDECLAREDITEM_H
 #define DEF_NAMEDDECLAREDITEM_H

 #include "declareditem.h"

namespace HYPER_Compiler {
	
	/**
		\brief Represents a DeclaredItem with a specific unique name. The name
		is unique inside some name scope.
	*/
	class NamedDeclaredItem : public DeclaredItem {
	public:
		virtual ~NamedDeclaredItem();
		
		virtual HYPER_Common::UTF8String getDeclarationName() const = 0;
	};
}
#endif
