/*!
	\file nat16class.h
	\author Kevin André
	\brief Contains the Nat16 class
	
	Copyright (C) 2005, 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2005-09-27
// Last time modified:	2009-02-08

#ifndef DEF_NAT16CLASS_H
 #define DEF_NAT16CLASS_H
 
 #include "builtinintegralclass.h"

namespace HYPER_Compiler {
	
	class BinaryOperator;
	
	/// Represents the built-in `nat16' class
	class Nat16 : public BuiltInIntegralClass {
	public:
		Nat16(CompileInfo& info);
		~Nat16();
		
		Type const* getAbsResultType() const;
		
		IntegerSize getNegateResultSize() const;
		Type const* getNegateResultType() const;
		
		Type const* getTruncateToSignedResultType() const;
		
	protected:
		void createConstructors();
		
		Type const* getClassType() const;
	};
}
#endif
