/*!
	\file outclass.h
	\author Kevin André
	\brief Contains the Out class
	
	Copyright (C) 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:	2006-12-20
// Date modified:	2008-10-13

#ifndef DEF_OUTCLASS_H
 #define DEF_OUTCLASS_H
 
 #include "builtinclass.h"

namespace HYPER_Compiler {
	
	/// Represents the built-in `system.Out' class
	class Out : public BuiltInClass {
	public:
		Out(CompileInfo& info);
		~Out();
		
		HYPER_Common::UTF8String getTypeName() const;
		
		void buildSymbolTable();
		
		HYPER_Common::UTF8String getDeclarationName() const;
		
	private:
		class ProcedureLine;
		class ProcedurePrint;
		
		void createMembers();
	};
}
#endif
