/*!
	\file overloadedassignmentoperator.h
	\brief Contains the OverloadedAssignmentOperator class
	\author Kevin André
	
	Copyright (C) 2005, 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2005-12-17
// Last time modified:	2008-06-17

#ifndef DEF_OVERLOADEDASSIGNMENTOPERATOR_H
 #define DEF_OVERLOADEDASSIGNMENTOPERATOR_H
 
 #include "assignmentoperator.h"
 
 #include <vector>

namespace HYPER_Compiler {
	
	/// Represents an overloaded assignment operator
	class OverloadedAssignmentOperator {
	public:
		OverloadedAssignmentOperator(AssignmentOperator* firstOp);
		
		~OverloadedAssignmentOperator();
		
		void addOverload(AssignmentOperator* bo);
		
		Operators::AssignmentOperator getOperator() const;
		
		const std::vector<AssignmentOperator*>& getOverloads() const;
		
	private:
		Operators::AssignmentOperator fOp;
		std::vector<AssignmentOperator*> fOps;
	};
}
#endif
