/*!
	\file overloadedconstructor.h
	\brief Contains the OverloadedConstructor class
	\author Kevin André
	
	Copyright (C) 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2006-06-08
// Last time modified:	2008-02-15

#ifndef DEF_OVERLOADEDCONSTRUCTOR_H
 #define DEF_OVERLOADEDCONSTRUCTOR_H
 
 #include "nameddeclareditem.h"
 #include "constructor.h"
 #include "overloadlist.h"

namespace HYPER_Compiler {
	
	/// Represents an overloaded constructor
	class OverloadedConstructor
		: public OverloadList<Constructor>, public DeclaredItem
	{
	public:
		OverloadedConstructor(Constructor* c);
		
		typedef Constructor OverloadEntity;
		
		HYPER_Common::UTF8String getDescription() const;
		Class const* getOwnerClass() const;
		
		ClassMemberAccess getAccessInOwner() const;
		
		Location const* getLocation() const;
	};
}
#endif
