/*!
	\file parameter.h
	\brief Contains the Parameter class.
	\author Kevin André
	
	Copyright (C) 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2008-10-11
// Last time modified:	2008-10-23

#ifndef DEF_PARAMETER_H
 #define DEF_PARAMETER_H
 
 #include "simpleparameter.h"
 
namespace HYPER_Compiler {
	
	class Location;
	
	/// Is a SimpleParameter with additionally a name and a location
	class Parameter : public SimpleParameter {
	public:
		Parameter(Type const* type, Passing passing,
			HYPER_Common::UTF8String name, Location const* loc);
		
		HYPER_Common::UTF8String getName() const {
			return fName;
		}
		
		Location const* getLocation() const {
			return fLoc;
		}
		
		HYPER_Common::UTF8String toString() const;
		
	private:
		HYPER_Common::UTF8String fName;
		Location const* fLoc;
	};
}
#endif
