#! /usr/bin/env bash
#
# ===================================
# Hyper Compiler Source files counter
# ===================================
#
# Copyright (C) 2005, 2006, 2007, 2008, 2009  Kevin André
#
#	This file is part of the Hyper Compiler, a compiler for the Hyper
#	programming language.
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License along
#	with this program; see the file GPLv3_license.txt.  If not, see
#	<http://www.gnu.org/licenses/>.
#

SCRIPTDIR=$(dirname $0)
cd $SCRIPTDIR/..

SOURCEFILELIST=sourcecount_sourcefile_list
rm -f $SOURCEFILELIST
touch $SOURCEFILELIST

if [ x"$1" == "x-noheaders" ] ; then
	find base/ -maxdepth 1 -name '*.cxx' >> $SOURCEFILELIST
	find common/ -maxdepth 1 -name '*.cxx' >> $SOURCEFILELIST
	find compiler/ -maxdepth 1 -name '*.cxx' >> $SOURCEFILELIST
	find lexer/ -maxdepth 1 -name '*.cxx' >> $SOURCEFILELIST
	echo "(not counting header files)"
	echo
else
	find base/ -maxdepth 1 -name '*.cxx' -o -name '*.h' >> $SOURCEFILELIST
	find common/ -maxdepth 1 -name '*.cxx' -o -name '*.h' >> $SOURCEFILELIST
	find compiler/ -maxdepth 1 -name '*.cxx' -o -name '*.h' >> $SOURCEFILELIST
	find lexer/ -maxdepth 1 -name '*.cxx' -o -name '*.h' >> $SOURCEFILELIST
	echo "(counting header files too)"
	echo
fi

FILES=$(cat $SOURCEFILELIST | xargs)

OS=$(uname)
if [[ $OS = Linux ]]
then
	wc -l $FILES | sort -g | sed 's| \./| |g'
else
	# sort uses an other parameter on Solaris
	wc -l $FILES | sort -n | sed 's| \./| |g'
fi

echo
echo -n "File count: "
wc -l $SOURCEFILELIST | sed -e 's/^ *//' | cut -d' ' -f1

rm -f $SOURCEFILELIST
