/**
	\file		syntaxitem.h
	\brief	Base class for syntax items
	\author	Kevin André
	
	Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2004-04-03
// Last time modified:	2008-02-20

#ifndef DEF_SYNTAXITEM_H
 #define DEF_SYNTAXITEM_H
 
 #include "common/streams_fwdecl.h"
 #include "common/utf8string.h"

namespace HYPER_Compiler {
	
	/// Base class for syntactical elements
	class SyntaxItem {
	public:
		SyntaxItem();
		virtual ~SyntaxItem();
		
		virtual HYPER_Common::UTF8String getSyntaxName() const = 0;
		virtual void myPrint(HYPER_Common::UTF8TextFlowStream& ind) const = 0;
	};
}
#endif
