/*!
	\file fileexceptions.h
	\brief Contains some exception classes concerning files.
	\author Kevin André
	
	Copyright (C) 2004, 2005, 2006, 2007, 2008  Kevin André
	
	This file is part of the Hyper Compiler, a compiler for the Hyper
	programming language.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; see the file GPLv3_license.txt.  If not, see
	<http://www.gnu.org/licenses/>.
	
*/
// Date created:		2007-02-16
// Last time modified:	2007-10-25

#ifndef DEF_FILEEXCEPTIONS_H
 #define DEF_FILEEXCEPTIONS_H
 
 #include "common/exception.h"

namespace HYPER_Compiler {
	
	/**
		\brief Exception that occurs when a file is not readable
	*/
	class FileNotReadableException : public HYPER_Common::Exception {
		//
	};
	
	/**
		\brief Exception that occurs when the end of a file (stream) is reached
		unexpectedly
	*/
	class EndOfFileException : public HYPER_Common::Exception {
		//
	};
}
#endif
